(define-module (alterator ensign backend2)
	       :use-module (srfi srfi-1)
	       :use-module (alterator algo)

	       :use-module (alterator security wrap)
	       :use-module (alterator ensign evaluation)
	       :use-module (alterator str)

	       :export (read-backend2
			make-backend2))

(define (read-backend2 path)
  (with-input-from-file
    path
    (lambda()
      (apply  backend->toplevel-begin
	      (unfold eof-object? values (lambda (x) (read)) (read))))))

(define (make-backend2 name)
  (with-first-readable
    (map (lambda (a) (string-append a "/backend2/" name))
	 (string-cut (getenv "ALTERATOR_LIBDIR") #\:))
    (lambda(path)
      (ensign-eval (read-backend2 path)))))
