(define-module (alterator common)
	       :export (alterator-init alterator-init-local))

(define (alterator-init)
  (or (getenv "ALTERATOR_DATADIR")
      (setenv "ALTERATOR_DATADIR" "/usr/share/alterator"))
  (or (getenv "ALTERATOR_LIBDIR")
      (setenv "ALTERATOR_LIBDIR" "/usr/lib/alterator")))

(define (alterator-init-local)
  (setenv "ALTERATOR_DATADIR"
	  (string-append "." ":" (getenv "ALTERATOR_DATADIR")))
  (setenv "ALTERATOR_LIBDIR"
	  (string-append "." ":" (getenv "ALTERATOR_LIBDIR"))))

